#include <stdio.h>
#include <string.h>
/*
  Write a function undef that will remove a name and definition from the table maintained by lookup and install
*/
  
unsigned int hash(char *s);
struct nlist *lookup(char *name);
struct nlist *install(char *name, char *defn);
void undef(char *name);

struct nlist{
  char *name;
  char *defn;
  struct nlist *next;
};
#define HASHSIZE 101

static struct nlist *hashtab[HASHSIZE];

unsigned int hash(char *s)
{
  unsigned hashval;

  for(hashval = 0; *s != '\0'; ++s)
    hashval = *s + 31 * hashval;
  return hashval % HASHSIZE;
}


struct nlist *lookup(char *name)
{
  struct nlist *np;
  for(np = hashtab[hash(name)]; np != NULL; np = np->next;){
    if(strcmp(name, np->name) == 0)
      return np;
  }
  return NULL;
}


struct nlist *install(char *name, char *defn)
{
  struct nlist *np;
  unsigned int hashval;
  if((np = lookup(name)) == NULL){
    np = (struct nlist*) malloc(sizeof(struct nlist));
    if(np == NULL || (np->name = strdup(name)) == NULL)
      return NULL;
    hashval = hash(name);
    np->next = hashtab[hashval];
    hashtab[hashval] = np;
  }
  else{
    free(np->defn);
  }
  if((np->defn = strdup(defn)) == NULL)
    return NULL;
  return np;
}

void undef(char *name)
{
  struct nlist *np, **prev;
  unsigned int hashval;
  hashval = hash(name);
  np = hashtab[hashval];
  prev = &hashtab[hashval];
  for(; np != NULL; prev = &(np->next), np = np->next){
    if(strcmp(name, np->name) == 0){
      *prev = np->next;
      free(np->name);
      free(np->defn);
      free(np);
      break;
    }
  }
}
  

  
